/* Centaur Color
 *
 * Version 1.1
 * 2/13/2021
 *
 * color.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "color.h"

#define PROG_HELP \
"Color Utility: Return an ANSI escape sequence for a color or stylization\n\
\n\
color [-H] [-t] <code ...>\n\
\n\
\t[-H] - Display program syntax and options\n\
\t[-t] - Display the table of color names and codes used with this program\n\
\n\
\t<code> may be the name or number of a color or stylization code.\n"

int ansi_code_table(void)
{
	printf("Color\tANSI Code\n");
	printf("\e[30mblack\e[0m\t  \\e[30m\n");
	printf("\e[31mred\e[0m\t  \\e[31m\n");
	printf("\e[32mgreen\e[0m\t  \\e[32m\n");
	printf("\e[33myellow\e[0m\t  \\e[33m\n");
	printf("\e[34mblue\e[0m\t  \\e[34m\n");
	printf("\e[35mpurple\e[0m\t  \\e[35m\n");
	printf("\e[36mcyan\e[0m\t  \\e[36m\n");
	printf("\e[37mwhite\e[0m\t  \\e[37m\n");
	printf("\e[1mbold\e[0m\t  \\e[1m\n");
	printf("\e[4munderline\e[0m \\e[4m\n");
	printf("\e[7mreverse\e[0m\t  \\e[7m\n");
	printf("clear\t  \\e[2J\\e[;H\n");
	printf("0mreset\e[0m\t  \\e[0m\n");
	return(0);
}

int main(int argc, char *argv[])
{
	if (argc < 2 || (argc >= 2 && argv[1][0] == '-' && argv[1][1] == 'H'))
	{
		printf(PROG_HELP);
		exit(1);
	}

	if (argv[1][0] == '-' && argv[1][1] == 't')
	{
		ansi_code_table();
		exit(0);
	}

	int x;

	for (x = 1; x <= (argc - 1); x++)
	{
		if (!strcmp(argv[x], "black") || atoi(argv[x]) == 30) {
			printf(BLACK);
		} else if (!strcmp(argv[x], "red") || atoi(argv[x]) == 31) {
			printf(RED);
		} else if (!strcmp(argv[x], "green") || atoi(argv[x]) == 32) {
			printf(GREEN);
		} else if (!strcmp(argv[x], "yellow") || atoi(argv[x]) == 33 ) {
			printf(YELLOW);
		} else if (!strcmp(argv[x], "blue") || atoi(argv[x]) == 34) {
			printf(BLUE);
		} else if (!strcmp(argv[x], "purple") || atoi(argv[x]) == 35) {
			printf(PURPLE);
		} else if (!strcmp(argv[x], "cyan") || atoi(argv[x]) == 36) {
			printf(CYAN);
		} else if (!strcmp(argv[x], "white") || atoi(argv[x]) == 37) {
			printf(WHITE);
		} else if (!strcmp(argv[x], "bold") || atoi(argv[x]) == 1) {
			printf(BOLD);
		} else if (!strcmp(argv[x], "line") || atoi(argv[x]) == 4) {
			printf(LINE);
		} else if (!strcmp(argv[x], "reverse") || atoi(argv[x]) == 7) {
			printf(REVERSE);
		} else if (!strcmp(argv[x], "clear") || atoi(argv[x]) == 2) {
			printf(CLEAR);
		} else if (!strcmp(argv[x], "reset") || atoi(argv[x]) == 0) {
			printf(RESET);
		} else {
			printf("%s: code \"%s\" not found\n", argv[0], argv[x]);
		}
	}
	exit(0);
}
